
class Shape {
	protected int x, y;
	public void draw() {		System.out.println("Shape Draw");	}
}

class Rectangle extends Shape {
	private int width, height;
	public void draw() {		System.out.println("Rectangle Draw"); }
}

class Triangle extends Shape {
	private int base, height;
	public void draw() {		System.out.println("Triangle Draw"); 	}
}

class Circle extends Shape {
	private int radius;
	public void draw() {		System.out.println("Circle Draw");	} 
}

public class ShapeTest4 {
	public static void print(Shape obj) {
		if (obj instanceof Rectangle) 
			System.out.println(" Ÿ Rectangle");
		if (obj instanceof Triangle) 
			System.out.println(" Ÿ Triangle");
		if (obj instanceof Circle) 
			System.out.println(" Ÿ Circle");
	}

	public static void main(String arg[]) {
		Rectangle s1 = new Rectangle();
		Triangle s2 = new Triangle();
		Circle s3 = new Circle();

		print(s1);
		print(s2);
		print(s3);
	}
}
